export declare enum Density {
    Normal = "Normal",
    Dense = "Dense"
}
export declare enum Visibility {
    Private = "Private",
    Crate = "Crate",
    Public = "Public"
}
type NameToParts = (name: string) => string[];
type PartsToName = (parts: string[]) => string;
interface NamingStyle {
    fromParts: PartsToName;
    regex: RegExp;
    toParts: NameToParts;
}
export declare const namingStyles: Record<string, NamingStyle>;
export declare const snakeNamingFunction: import("../../Naming").Namer;
export declare const camelNamingFunction: import("../../Naming").Namer;
export declare const rustStringEscape: (s: string) => string;
export declare function getPreferedNamingStyle(namingStyleOccurences: string[], defaultStyle: string): string;
export declare function listMatchingNamingStyles(name: string): string[];
export declare function nameToNamingStyle(name: string, style: string): string;
export {};
